searchNodes=[{"doc":"Boruta is the core of an OAuth provider giving business logic of authentication and authorization.Documentation","ref":"Boruta.html","title":"Boruta","type":"module"},{"doc":"Utilities to access Boruta configuration ad set defaults.Configuration can be set as following in config.exs (this configuration is the default)config :boruta, Boruta.Oauth, repo: MyApp.Repo, # mandatory cache_backend: Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: MyApp.ResourceOwners, # mandatory scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24, id_token: 60 * 60 * 24, refresh_token: 60 * 60 * 24 * 30 ], token_generator: Boruta.TokenGenerator, issuer: &quot;https://issuer.com&quot;","ref":"Boruta.Config.html","title":"Boruta.Config","type":"module"},{"doc":"Administration of Boruta resources.","ref":"Boruta.Ecto.Admin.html","title":"Boruta.Ecto.Admin","type":"module"},{"doc":"See Boruta.Ecto.Admin.Clients.create_client/1.","ref":"Boruta.Ecto.Admin.html#create_client/1","title":"Boruta.Ecto.Admin.create_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.create_scope/1.","ref":"Boruta.Ecto.Admin.html#create_scope/1","title":"Boruta.Ecto.Admin.create_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.delete_client/1.","ref":"Boruta.Ecto.Admin.html#delete_client/1","title":"Boruta.Ecto.Admin.delete_client/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.delete_scope/1.","ref":"Boruta.Ecto.Admin.html#delete_scope/1","title":"Boruta.Ecto.Admin.delete_scope/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.get_client!/1.","ref":"Boruta.Ecto.Admin.html#get_client!/1","title":"Boruta.Ecto.Admin.get_client!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scope!/1.","ref":"Boruta.Ecto.Admin.html#get_scope!/1","title":"Boruta.Ecto.Admin.get_scope!/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1.","ref":"Boruta.Ecto.Admin.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.get_scopes_by_ids/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.list_active_tokens/0.","ref":"Boruta.Ecto.Admin.html#list_active_tokens/0","title":"Boruta.Ecto.Admin.list_active_tokens/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Tokens.list_active_tokens/1.","ref":"Boruta.Ecto.Admin.html#list_active_tokens/1","title":"Boruta.Ecto.Admin.list_active_tokens/1","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.list_clients/0.","ref":"Boruta.Ecto.Admin.html#list_clients/0","title":"Boruta.Ecto.Admin.list_clients/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.list_scopes/0.","ref":"Boruta.Ecto.Admin.html#list_scopes/0","title":"Boruta.Ecto.Admin.list_scopes/0","type":"function"},{"doc":"See Boruta.Ecto.Admin.Clients.update_client/2.","ref":"Boruta.Ecto.Admin.html#update_client/2","title":"Boruta.Ecto.Admin.update_client/2","type":"function"},{"doc":"See Boruta.Ecto.Admin.Scopes.update_scope/2.","ref":"Boruta.Ecto.Admin.html#update_scope/2","title":"Boruta.Ecto.Admin.update_scope/2","type":"function"},{"doc":"Boruta OAuth entrypoint, handles OAuth requests.Note : this module follows inverted heaxagonal architecture, its functions will invoke functions of the given argument module as result. The definition of the callbacks are provided by either Boruta.Oauth.Application or Boruta.Oauth.AuthorizeApplication, Boruta.Oauth.TokenApplication, Boruta.Oauth.IntrospectApplication, and Boruta.Oauth.RevokeApplication,","ref":"Boruta.Oauth.html","title":"Boruta.Oauth","type":"module"},{"doc":"Process an authorize request and returns a token as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers authorize_success in case of success and authorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#authorize/3","title":"Boruta.Oauth.authorize/3","type":"function"},{"doc":"Process a introspect request as stated in RFC 7662 - OAuth 2.0 Token Introspection.Triggers introspect_success in case of success and introspect_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#introspect/2","title":"Boruta.Oauth.introspect/2","type":"function"},{"doc":"Process an authorize request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers preauthorize_success in case of success and preauthorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#preauthorize/3","title":"Boruta.Oauth.preauthorize/3","type":"function"},{"doc":"Process a revoke request as stated in RFC 7009 - OAuth 2.0 Token Revocation.Triggers revoke_success in case of success and revoke_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#revoke/2","title":"Boruta.Oauth.revoke/2","type":"function"},{"doc":"Process an token request as stated in RFC 6749 - The OAuth 2.0 Authorization Framework.Triggers token_success in case of success and token_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour.","ref":"Boruta.Oauth.html#token/2","title":"Boruta.Oauth.token/2","type":"function"},{"doc":"OAuth application behaviourImplement this behaviour in the application layer of your OAuth provider. This behaviour gives all callbacks that are triggered invoking Boruta.Oauth module functions. Boruta.Oauth.AuthorizeApplication, Boruta.Oauth.TokenApplication, Boruta.Oauth.IntrospectApplication, and Boruta.Oauth.RevokeApplication are here to implement the different Oauth endpoints separatly.","ref":"Boruta.Oauth.Application.html","title":"Boruta.Oauth.Application","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_error/2","title":"Boruta.Oauth.Application.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.Application.html#c:authorize_success/2","title":"Boruta.Oauth.Application.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_error/2","title":"Boruta.Oauth.Application.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.Application.html#c:introspect_success/2","title":"Boruta.Oauth.Application.introspect_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_error/2","title":"Boruta.Oauth.Application.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.Application.html#c:preauthorize_success/2","title":"Boruta.Oauth.Application.preauthorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_error/2","title":"Boruta.Oauth.Application.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.Application.html#c:revoke_success/1","title":"Boruta.Oauth.Application.revoke_success/1","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_error/2","title":"Boruta.Oauth.Application.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.Application.html#c:token_success/2","title":"Boruta.Oauth.Application.token_success/2","type":"callback"},{"doc":"This task will help creation of a basic OAuth server by providing needed phoenix controllers, views and templates helping OAuth endpoints exposition.All flows involving resource owners need its integration guided by Boruta.Oauth.ResourceOwners behaviour. For authorize endpoint, you'll need to assign current_user with a plug or so and setup login redirections which should raise an error where it is needed.Controllers are unit tested using Mox, you'll need to add that dependency in order to run them (see below).Examplesmix boruta.gen.controllersPost instalation stepsYou can add OAuth routes in web application router as follow to expose controller actionsscope &quot;/oauth&quot;, MyAppWeb.Oauth do pipe_through :api post &quot;/revoke&quot;, RevokeController, :revoke post &quot;/token&quot;, TokenController, :token post &quot;/introspect&quot;, IntrospectController, :introspect end scope &quot;/oauth&quot;, MyAppWeb.Oauth do pipe_through [:browser] get &quot;/authorize&quot;, AuthorizeController, :authorize end scope &quot;/openid&quot;, MyAppWeb.Openid do pipe_through [:browser] get &quot;/authorize&quot;, AuthorizeController, :authorize endAdd following in config/config.exs to inject Boruta.Oauth dependencyconfig :myapp, :oauth_module, Boruta.OauthTestingAdd mox dependency in order to run controller unit tests{:mox, &quot;~&gt; 0.5&quot;, only: :test}Add following in config/test.exsconfig :myapp, :oauth_module, Boruta.OauthMockAdd following in test/test_helper.exsMox.defmock(Boruta.OauthMock, for: Boruta.OauthModule)","ref":"Mix.Tasks.Boruta.Gen.Controllers.html","title":"Mix.Tasks.Boruta.Gen.Controllers","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Boruta.Gen.Controllers.html#run/1","title":"Mix.Tasks.Boruta.Gen.Controllers.run/1","type":"function"},{"doc":"Migration task for Boruta.Creates clients, scopes and tokens tables.Note: This task will create migration files to keep your integration up to date by checking migration file and module names to create missing ones. Thus it is not recommanded to change those since it will break the process.Examplesmix boruta.gen.migration","ref":"Mix.Tasks.Boruta.Gen.Migration.html","title":"Mix.Tasks.Boruta.Gen.Migration","type":"task"},{"doc":"OAuth application behaviour - authorize endpointImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.AuthorizeApplication.html","title":"Boruta.Oauth.AuthorizeApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:authorize_error/2","title":"Boruta.Oauth.AuthorizeApplication.authorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.authorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:authorize_success/2","title":"Boruta.Oauth.AuthorizeApplication.authorize_success/2","type":"callback"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:preauthorize_error/2","title":"Boruta.Oauth.AuthorizeApplication.preauthorize_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.preauthorize/3","ref":"Boruta.Oauth.AuthorizeApplication.html#c:preauthorize_success/2","title":"Boruta.Oauth.AuthorizeApplication.preauthorize_success/2","type":"callback"},{"doc":"OAuth application behaviour - introspect endpointImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.IntrospectApplication.html","title":"Boruta.Oauth.IntrospectApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.IntrospectApplication.html#c:introspect_error/2","title":"Boruta.Oauth.IntrospectApplication.introspect_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.introspect/2","ref":"Boruta.Oauth.IntrospectApplication.html#c:introspect_success/2","title":"Boruta.Oauth.IntrospectApplication.introspect_success/2","type":"callback"},{"doc":"OAuth application behaviour - revoke endpointImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.RevokeApplication.html","title":"Boruta.Oauth.RevokeApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.RevokeApplication.html#c:revoke_error/2","title":"Boruta.Oauth.RevokeApplication.revoke_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.revoke/2","ref":"Boruta.Oauth.RevokeApplication.html#c:revoke_success/1","title":"Boruta.Oauth.RevokeApplication.revoke_success/1","type":"callback"},{"doc":"OAuth application behaviour - token endpointImplement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module.","ref":"Boruta.Oauth.TokenApplication.html","title":"Boruta.Oauth.TokenApplication","type":"behaviour"},{"doc":"This function will be triggered in case of failure invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.TokenApplication.html#c:token_error/2","title":"Boruta.Oauth.TokenApplication.token_error/2","type":"callback"},{"doc":"This function will be triggered in case of success invoking Boruta.Oauth.token/2","ref":"Boruta.Oauth.TokenApplication.html#c:token_success/2","title":"Boruta.Oauth.TokenApplication.token_success/2","type":"callback"},{"doc":"Authorize response","ref":"Boruta.Oauth.AuthorizeResponse.html","title":"Boruta.Oauth.AuthorizeResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#from_tokens/1","title":"Boruta.Oauth.AuthorizeResponse.from_tokens/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#redirect_to_url/1","title":"Boruta.Oauth.AuthorizeResponse.redirect_to_url/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.AuthorizeResponse.html#t:t/0","title":"Boruta.Oauth.AuthorizeResponse.t/0","type":"type"},{"doc":"Introspect response","ref":"Boruta.Oauth.IntrospectResponse.html","title":"Boruta.Oauth.IntrospectResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_error/1","title":"Boruta.Oauth.IntrospectResponse.from_error/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#from_token/1","title":"Boruta.Oauth.IntrospectResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.IntrospectResponse.html#t:t/0","title":"Boruta.Oauth.IntrospectResponse.t/0","type":"type"},{"doc":"Token response","ref":"Boruta.Oauth.TokenResponse.html","title":"Boruta.Oauth.TokenResponse","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#from_token/1","title":"Boruta.Oauth.TokenResponse.from_token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.TokenResponse.html#t:t/0","title":"Boruta.Oauth.TokenResponse.t/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.Authorization.html","title":"Boruta.Oauth.Authorization","type":"protocol"},{"doc":"Checks if request is valid for token creation for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#preauthorize/1","title":"Boruta.Oauth.Authorization.preauthorize/1","type":"function"},{"doc":"Creates and returns a token for given request, depending of implementation.","ref":"Boruta.Oauth.Authorization.html#token/1","title":"Boruta.Oauth.Authorization.token/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.html#t:t/0","title":"Boruta.Oauth.Authorization.t/0","type":"type"},{"doc":"Access token authorization","ref":"Boruta.Oauth.Authorization.AccessToken.html","title":"Boruta.Oauth.Authorization.AccessToken","type":"module"},{"doc":"Authorize the access token corresponding to the given params.Examplesiex&gt; authorize(%{value: &quot;value&quot;}) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.AccessToken.html#authorize/1","title":"Boruta.Oauth.Authorization.AccessToken.authorize/1","type":"function"},{"doc":"Client authorization","ref":"Boruta.Oauth.Authorization.Client.html","title":"Boruta.Oauth.Authorization.Client","type":"module"},{"doc":"Authorize the client corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;, secret: &quot;secret&quot;) {:ok, %Boruta.Oauth.Client{...}}","ref":"Boruta.Oauth.Authorization.Client.html#authorize/1","title":"Boruta.Oauth.Authorization.Client.authorize/1","type":"function"},{"doc":"Code authorization","ref":"Boruta.Oauth.Authorization.Code.html","title":"Boruta.Oauth.Authorization.Code","type":"module"},{"doc":"Authorize the code corresponding to the given params.Examplesiex&gt; authorize(value: &quot;value&quot;, redirect_uri: &quot;redirect_uri&quot;) {:ok, %Boruta.Oauth.Token{...}}","ref":"Boruta.Oauth.Authorization.Code.html#authorize/1","title":"Boruta.Oauth.Authorization.Code.authorize/1","type":"function"},{"doc":"OpenID Connect nonce authorization","ref":"Boruta.Oauth.Authorization.Nonce.html","title":"Boruta.Oauth.Authorization.Nonce","type":"protocol"},{"doc":"","ref":"Boruta.Oauth.Authorization.Nonce.html#authorize/1","title":"Boruta.Oauth.Authorization.Nonce.authorize/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Authorization.Nonce.html#t:t/0","title":"Boruta.Oauth.Authorization.Nonce.t/0","type":"type"},{"doc":"Resource owner authorization","ref":"Boruta.Oauth.Authorization.ResourceOwner.html","title":"Boruta.Oauth.Authorization.ResourceOwner","type":"module"},{"doc":"Authorize the resource owner corresponding to the given params.Examplesiex&gt; authorize(id: &quot;id&quot;) {:ok, %User{...}}","ref":"Boruta.Oauth.Authorization.ResourceOwner.html#authorize/1","title":"Boruta.Oauth.Authorization.ResourceOwner.authorize/1","type":"function"},{"doc":"Scope authorization","ref":"Boruta.Oauth.Authorization.Scope.html","title":"Boruta.Oauth.Authorization.Scope","type":"module"},{"doc":"Authorize the given scope according to the given client.Examplesiex&gt; authorize(%{scope: &quot;scope&quot;, client: %Client{...}}) {:ok, &quot;scope&quot;}","ref":"Boruta.Oauth.Authorization.Scope.html#authorize/1","title":"Boruta.Oauth.Authorization.Scope.authorize/1","type":"function"},{"doc":"Struct encapsulating an authorization success","ref":"Boruta.Oauth.AuthorizationSuccess.html","title":"Boruta.Oauth.AuthorizationSuccess","type":"module"},{"doc":"","ref":"Boruta.Oauth.AuthorizationSuccess.html#t:t/0","title":"Boruta.Oauth.AuthorizationSuccess.t/0","type":"type"},{"doc":"OAuth Introspect","ref":"Boruta.Oauth.Introspect.html","title":"Boruta.Oauth.Introspect","type":"module"},{"doc":"Returns corresponding token for the given Boruta.Oauth.IntrospectRequestNote : Invalid tokens returns an error {:error, %Error{error: :invalid_access_token, ...}}. That must be rescued to return %{&quot;active&quot; =&gt; false} in application implementation.Examplesiex&gt; token(%IntrospectRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) {:ok, %Token{...}}","ref":"Boruta.Oauth.Introspect.html#token/1","title":"Boruta.Oauth.Introspect.token/1","type":"function"},{"doc":"OAuth Revoke","ref":"Boruta.Oauth.Revoke.html","title":"Boruta.Oauth.Revoke","type":"module"},{"doc":"Revokes token according to the given Boruta.Oauth.RevokeRequestExamplesiex&gt; token(%RevokeRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) :ok","ref":"Boruta.Oauth.Revoke.html#token/1","title":"Boruta.Oauth.Revoke.token/1","type":"function"},{"doc":"Access token context","ref":"Boruta.Oauth.AccessTokens.html","title":"Boruta.Oauth.AccessTokens","type":"behaviour"},{"doc":"Persists a token with the given params.","ref":"Boruta.Oauth.AccessTokens.html#c:create/2","title":"Boruta.Oauth.AccessTokens.create/2","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token either by value or refresh_token.","ref":"Boruta.Oauth.AccessTokens.html#c:get_by/1","title":"Boruta.Oauth.AccessTokens.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token.","ref":"Boruta.Oauth.AccessTokens.html#c:revoke/1","title":"Boruta.Oauth.AccessTokens.revoke/1","type":"callback"},{"doc":"Client context","ref":"Boruta.Oauth.Clients.html","title":"Boruta.Oauth.Clients","type":"behaviour"},{"doc":"Returns client authorized scopes. The scopes will be granted for every requests to the given client.","ref":"Boruta.Oauth.Clients.html#c:authorized_scopes/1","title":"Boruta.Oauth.Clients.authorized_scopes/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Client given id.","ref":"Boruta.Oauth.Clients.html#c:get_client/1","title":"Boruta.Oauth.Clients.get_client/1","type":"callback"},{"doc":"Code context","ref":"Boruta.Oauth.Codes.html","title":"Boruta.Oauth.Codes","type":"behaviour"},{"doc":"Persists a token according to given params.","ref":"Boruta.Oauth.Codes.html#c:create/1","title":"Boruta.Oauth.Codes.create/1","type":"callback"},{"doc":"Returns a Boruta.Oauth.Token by value and redirect_uri.","ref":"Boruta.Oauth.Codes.html#c:get_by/1","title":"Boruta.Oauth.Codes.get_by/1","type":"callback"},{"doc":"Revokes the given Boruta.Oauth.Token.","ref":"Boruta.Oauth.Codes.html#c:revoke/1","title":"Boruta.Oauth.Codes.revoke/1","type":"callback"},{"doc":"Resource owner context","ref":"Boruta.Oauth.ResourceOwners.html","title":"Boruta.Oauth.ResourceOwners","type":"behaviour"},{"doc":"Returns a list of authorized scopes for a given resource owner. These scopes will be granted is requested for the user.","ref":"Boruta.Oauth.ResourceOwners.html#c:authorized_scopes/1","title":"Boruta.Oauth.ResourceOwners.authorized_scopes/1","type":"callback"},{"doc":"Determines if given password is correct.","ref":"Boruta.Oauth.ResourceOwners.html#c:check_password/2","title":"Boruta.Oauth.ResourceOwners.check_password/2","type":"callback"},{"doc":"Returns id_token identity claims for the given resource owner","ref":"Boruta.Oauth.ResourceOwners.html#c:claims/2","title":"Boruta.Oauth.ResourceOwners.claims/2","type":"callback"},{"doc":"Returns a resource owner by (username, password) or (id). Returns nil for non matching results.","ref":"Boruta.Oauth.ResourceOwners.html#c:get_by/1","title":"Boruta.Oauth.ResourceOwners.get_by/1","type":"callback"},{"doc":"","ref":"Boruta.Oauth.ResourceOwners.html#t:claims/0","title":"Boruta.Oauth.ResourceOwners.claims/0","type":"type"},{"doc":"Scope context","ref":"Boruta.Oauth.Scopes.html","title":"Boruta.Oauth.Scopes","type":"behaviour"},{"doc":"","ref":"Boruta.Oauth.Scopes.html#c:public/0","title":"Boruta.Oauth.Scopes.public/0","type":"callback"},{"doc":"OAuth client schema","ref":"Boruta.Oauth.Client.html","title":"Boruta.Oauth.Client","type":"module"},{"doc":"","ref":"Boruta.Oauth.Client.html#check_redirect_uri/2","title":"Boruta.Oauth.Client.check_redirect_uri/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#check_secret/2","title":"Boruta.Oauth.Client.check_secret/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#grant_type_supported?/2","title":"Boruta.Oauth.Client.grant_type_supported?/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#public_refresh_token?/1","title":"Boruta.Oauth.Client.public_refresh_token?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#public_revoke?/1","title":"Boruta.Oauth.Client.public_revoke?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Client.html#t:t/0","title":"Boruta.Oauth.Client.t/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.IdToken.html","title":"Boruta.Oauth.IdToken","type":"module"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#generate/2","title":"Boruta.Oauth.IdToken.generate/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.IdToken.html#t:tokens/0","title":"Boruta.Oauth.IdToken.tokens/0","type":"type"},{"doc":"Oauth resource owner","ref":"Boruta.Oauth.ResourceOwner.html","title":"Boruta.Oauth.ResourceOwner","type":"module"},{"doc":"","ref":"Boruta.Oauth.ResourceOwner.html#t:t/0","title":"Boruta.Oauth.ResourceOwner.t/0","type":"type"},{"doc":"Schema defining an independent OAuth scope","ref":"Boruta.Oauth.Scope.html","title":"Boruta.Oauth.Scope","type":"module"},{"doc":"Determines if artifact is authorized to access given scope.","ref":"Boruta.Oauth.Scope.html#authorized_scopes/3","title":"Boruta.Oauth.Scope.authorized_scopes/3","type":"function"},{"doc":"Determines if scope string contains openid scope.","ref":"Boruta.Oauth.Scope.html#contains_openid?/1","title":"Boruta.Oauth.Scope.contains_openid?/1","type":"function"},{"doc":"Returns 'openid' scope","ref":"Boruta.Oauth.Scope.html#openid/0","title":"Boruta.Oauth.Scope.openid/0","type":"function"},{"doc":"Splits an OAuth scope string into individual scopes as stringExamplesiex&gt; scope(&quot;a:scope another:scope&quot;) [&quot;a:scope&quot;, &quot;another:scope&quot;]","ref":"Boruta.Oauth.Scope.html#split/1","title":"Boruta.Oauth.Scope.split/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:raw/0","title":"Boruta.Oauth.Scope.raw/0","type":"type"},{"doc":"","ref":"Boruta.Oauth.Scope.html#t:t/0","title":"Boruta.Oauth.Scope.t/0","type":"type"},{"doc":"Token schema. Representing both access tokens and codes.","ref":"Boruta.Oauth.Token.html","title":"Boruta.Oauth.Token","type":"module"},{"doc":"Determines if a token is valid, neither expired nor revoked.Examplesiex&gt; ensure_valid(%Boruta.Oauth.Token{revoked_at: nil}) :ok iex&gt; ensure_valid(%Boruta.Oauth.Token{}) {:error, &quot;Token revoked.&quot;}","ref":"Boruta.Oauth.Token.html#ensure_valid/2","title":"Boruta.Oauth.Token.ensure_valid/2","type":"function"},{"doc":"Determines if a token is expiredExamplesiex&gt; expired?(%Boruta.Oauth.Token{expires_at: 1628260754}) false iex&gt; expired?(%Boruta.Oauth.Token{expires_at: 0}) # 1st january 1970 true","ref":"Boruta.Oauth.Token.html#expired?/3","title":"Boruta.Oauth.Token.expired?/3","type":"function"},{"doc":"Returns an hexadecimal SHA512 hash of given stringExamplesiex&gt; hash(&quot;foo&quot;) &quot;F7FBBA6E0636F890E56FBBF3283E524C6FA3204AE298382D624741D0DC6638326E282C41BE5E4254D8820772C5518A2C5A8C0C7F7EDA19594A7EB539453E1ED7&quot;","ref":"Boruta.Oauth.Token.html#hash/1","title":"Boruta.Oauth.Token.hash/1","type":"function"},{"doc":"Determines if a token is revoked.Examplesiex&gt; revoked?(%Boruta.Oauth.Token{revoked_at: nil}) :ok iex&gt; revoked?(%Boruta.Oauth.Token{}) false","ref":"Boruta.Oauth.Token.html#revoked?/1","title":"Boruta.Oauth.Token.revoked?/1","type":"function"},{"doc":"","ref":"Boruta.Oauth.Token.html#t:t/0","title":"Boruta.Oauth.Token.t/0","type":"type"},{"doc":"Authorization code request","ref":"Boruta.Oauth.AuthorizationCodeRequest.html","title":"Boruta.Oauth.AuthorizationCodeRequest","type":"module"},{"doc":"Type representing an authorization code request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.AuthorizationCodeRequest.html#t:t/0","title":"Boruta.Oauth.AuthorizationCodeRequest.t/0","type":"type"},{"doc":"Client credentials request","ref":"Boruta.Oauth.ClientCredentialsRequest.html","title":"Boruta.Oauth.ClientCredentialsRequest","type":"module"},{"doc":"Type representing a client credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.ClientCredentialsRequest.html#t:t/0","title":"Boruta.Oauth.ClientCredentialsRequest.t/0","type":"type"},{"doc":"Code request","ref":"Boruta.Oauth.CodeRequest.html","title":"Boruta.Oauth.CodeRequest","type":"module"},{"doc":"","ref":"Boruta.Oauth.CodeRequest.html#require_nonce?/1","title":"Boruta.Oauth.CodeRequest.require_nonce?/1","type":"function"},{"doc":"Type representing a code request as stated in OAuth 2.0 RFC.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.CodeRequest.html#t:t/0","title":"Boruta.Oauth.CodeRequest.t/0","type":"type"},{"doc":"Hybrid request","ref":"Boruta.Oauth.HybridRequest.html","title":"Boruta.Oauth.HybridRequest","type":"module"},{"doc":"Type representing an hybrid request as stated in OpenId Connect core 1.0.Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.HybridRequest.html#t:t/0","title":"Boruta.Oauth.HybridRequest.t/0","type":"type"},{"doc":"Introspect request","ref":"Boruta.Oauth.IntrospectRequest.html","title":"Boruta.Oauth.IntrospectRequest","type":"module"},{"doc":"Type representing an introspect request as stated in Introspect RFC.","ref":"Boruta.Oauth.IntrospectRequest.html#t:t/0","title":"Boruta.Oauth.IntrospectRequest.t/0","type":"type"},{"doc":"Resource owner password credentials request","ref":"Boruta.Oauth.PasswordRequest.html","title":"Boruta.Oauth.PasswordRequest","type":"module"},{"doc":"Type representing a resource owner password credentials request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.PasswordRequest.html#t:t/0","title":"Boruta.Oauth.PasswordRequest.t/0","type":"type"},{"doc":"Refresh token request","ref":"Boruta.Oauth.RefreshTokenRequest.html","title":"Boruta.Oauth.RefreshTokenRequest","type":"module"},{"doc":"Type representing a refresh token request as stated in OAuth 2.0 RFC.","ref":"Boruta.Oauth.RefreshTokenRequest.html#t:t/0","title":"Boruta.Oauth.RefreshTokenRequest.t/0","type":"type"},{"doc":"Build an oauth request struct from given input.Note : Input must have the shape or be a %Plug.Conn{} request.","ref":"Boruta.Oauth.Request.html","title":"Boruta.Oauth.Request","type":"module"},{"doc":"Create request struct from an OAuth authorize request.Note : resource owner must be provided as current_user assigns.Examplesiex&gt;authorize_request( %{ query_params: %{ &quot;response_type&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;redirect_uri&quot; =&gt; &quot;redirect_uri&quot; }, }, %User{...} ) {:ok, %TokenRequest{...}}","ref":"Boruta.Oauth.Request.html#authorize_request/2","title":"Boruta.Oauth.Request.authorize_request/2","type":"function"},{"doc":"Create request struct from an OAuth introspect request.Examplesiex&gt;introspect_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %IntrospectRequest{...}}","ref":"Boruta.Oauth.Request.html#introspect_request/1","title":"Boruta.Oauth.Request.introspect_request/1","type":"function"},{"doc":"Create request struct from an OAuth revoke request.Examplesiex&gt;revoke_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %RevokeRequest{...}}","ref":"Boruta.Oauth.Request.html#revoke_request/1","title":"Boruta.Oauth.Request.revoke_request/1","type":"function"},{"doc":"Create request struct from an OAuth token request.Examplesiex&gt;token_request(%{ body_params: %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } }) {:ok, %ClientCredentialsRequest{...}}","ref":"Boruta.Oauth.Request.html#token_request/1","title":"Boruta.Oauth.Request.token_request/1","type":"function"},{"doc":"Revoke request","ref":"Boruta.Oauth.RevokeRequest.html","title":"Boruta.Oauth.RevokeRequest","type":"module"},{"doc":"Type representing an revoke request as stated in OAuth 2.0 Token revocation RFC.","ref":"Boruta.Oauth.RevokeRequest.html#t:t/0","title":"Boruta.Oauth.RevokeRequest.t/0","type":"type"},{"doc":"Implicit request","ref":"Boruta.Oauth.TokenRequest.html","title":"Boruta.Oauth.TokenRequest","type":"module"},{"doc":"","ref":"Boruta.Oauth.TokenRequest.html#require_nonce?/1","title":"Boruta.Oauth.TokenRequest.require_nonce?/1","type":"function"},{"doc":"Type representing an implicit request as stated in OAuth 2.0 RFC and OpenId Connect core 1.0Note : resource_owner is an addition that must be provided by the application layer.","ref":"Boruta.Oauth.TokenRequest.html#t:t/0","title":"Boruta.Oauth.TokenRequest.t/0","type":"type"},{"doc":"Encapsulate injected access_tokens adapter in context configuration.","ref":"Boruta.AccessTokensAdapter.html","title":"Boruta.AccessTokensAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.create/2.","ref":"Boruta.AccessTokensAdapter.html#create/2","title":"Boruta.AccessTokensAdapter.create/2","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.get_by/1.","ref":"Boruta.AccessTokensAdapter.html#get_by/1","title":"Boruta.AccessTokensAdapter.get_by/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.AccessTokens.revoke/1.","ref":"Boruta.AccessTokensAdapter.html#revoke/1","title":"Boruta.AccessTokensAdapter.revoke/1","type":"function"},{"doc":"Boruta Ecto adapter uses Nebulex in order to cache entities","ref":"Boruta.Cache.html","title":"Boruta.Cache","type":"module"},{"doc":"A convenience function for getting the primary storage cache.","ref":"Boruta.Cache.html#__primary__/0","title":"Boruta.Cache.__primary__/0","type":"function"},{"doc":"A convenience function for joining the cache to the cluster.","ref":"Boruta.Cache.html#join_cluster/0","title":"Boruta.Cache.join_cluster/0","type":"function"},{"doc":"A convenience function for removing the cache from the cluster.","ref":"Boruta.Cache.html#leave_cluster/0","title":"Boruta.Cache.leave_cluster/0","type":"function"},{"doc":"A convenience function for getting the cluster nodes.","ref":"Boruta.Cache.html#nodes/0","title":"Boruta.Cache.nodes/0","type":"function"},{"doc":"This is the cache for the primary storage.","ref":"Boruta.Cache.Primary.html","title":"Boruta.Cache.Primary","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"Boruta.Cache.Primary.html#generations/0","title":"Boruta.Cache.Primary.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"Boruta.Cache.Primary.html#new_generation/1","title":"Boruta.Cache.Primary.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"Boruta.Cache.Primary.html#newer_generation/0","title":"Boruta.Cache.Primary.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"Boruta.Cache.Primary.html#reset_generation_timer/0","title":"Boruta.Cache.Primary.reset_generation_timer/0","type":"function"},{"doc":"Encapsulate injected clients adapter in context configuration.","ref":"Boruta.ClientsAdapter.html","title":"Boruta.ClientsAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Clients.authorized_scopes/1.","ref":"Boruta.ClientsAdapter.html#authorized_scopes/1","title":"Boruta.ClientsAdapter.authorized_scopes/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Clients.get_client/1.","ref":"Boruta.ClientsAdapter.html#get_client/1","title":"Boruta.ClientsAdapter.get_client/1","type":"function"},{"doc":"Encapsulate injected codes adapter in context configuration.","ref":"Boruta.CodesAdapter.html","title":"Boruta.CodesAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Codes.create/1.","ref":"Boruta.CodesAdapter.html#create/1","title":"Boruta.CodesAdapter.create/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Codes.get_by/1.","ref":"Boruta.CodesAdapter.html#get_by/1","title":"Boruta.CodesAdapter.get_by/1","type":"function"},{"doc":"Callback implementation for Boruta.Oauth.Codes.revoke/1.","ref":"Boruta.CodesAdapter.html#revoke/1","title":"Boruta.CodesAdapter.revoke/1","type":"function"},{"doc":"Encapsulate injected scopes adapter in context configuration.","ref":"Boruta.ScopesAdapter.html","title":"Boruta.ScopesAdapter","type":"module"},{"doc":"Callback implementation for Boruta.Oauth.Scopes.public/0.","ref":"Boruta.ScopesAdapter.html#public/0","title":"Boruta.ScopesAdapter.public/0","type":"function"},{"doc":"Ecto Adapter Client Schema","ref":"Boruta.Ecto.Client.html","title":"Boruta.Ecto.Client","type":"module"},{"doc":"","ref":"Boruta.Ecto.Client.html#create_changeset/2","title":"Boruta.Ecto.Client.create_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Client.html#update_changeset/2","title":"Boruta.Ecto.Client.update_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Client.html#t:t/0","title":"Boruta.Ecto.Client.t/0","type":"type"},{"doc":"Ecto Adapter Scope Schema","ref":"Boruta.Ecto.Scope.html","title":"Boruta.Ecto.Scope","type":"module"},{"doc":"","ref":"Boruta.Ecto.Scope.html#assoc_changeset/2","title":"Boruta.Ecto.Scope.assoc_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Scope.html#changeset/2","title":"Boruta.Ecto.Scope.changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Scope.html#t:t/0","title":"Boruta.Ecto.Scope.t/0","type":"type"},{"doc":"Ecto Adapter Token Schema","ref":"Boruta.Ecto.Token.html","title":"Boruta.Ecto.Token","type":"module"},{"doc":"","ref":"Boruta.Ecto.Token.html#changeset/2","title":"Boruta.Ecto.Token.changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#changeset_with_refresh_token/2","title":"Boruta.Ecto.Token.changeset_with_refresh_token/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#code_changeset/2","title":"Boruta.Ecto.Token.code_changeset/2","type":"function"},{"doc":"","ref":"Boruta.Ecto.Token.html#t:t/0","title":"Boruta.Ecto.Token.t/0","type":"type"},{"doc":"Boruta.Ecto.Client resource administration.","ref":"Boruta.Ecto.Admin.Clients.html","title":"Boruta.Ecto.Admin.Clients","type":"module"},{"doc":"Creates a client.Examplesiex&gt; create_client(%{field: value}) {:ok, %Client{}} iex&gt; create_client(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#create_client/1","title":"Boruta.Ecto.Admin.Clients.create_client/1","type":"function"},{"doc":"Deletes a Client.Examplesiex&gt; delete_client(client) {:ok, %Client{}} iex&gt; delete_client(client) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#delete_client/1","title":"Boruta.Ecto.Admin.Clients.delete_client/1","type":"function"},{"doc":"Gets a single client.Raises Ecto.NoResultsError if the Client does not exist.Examplesiex&gt; get_client!(123) %Client{} iex&gt; get_client!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Clients.html#get_client!/1","title":"Boruta.Ecto.Admin.Clients.get_client!/1","type":"function"},{"doc":"Returns the list of clients.Examplesiex&gt; list_clients() [%Client{}, ...]","ref":"Boruta.Ecto.Admin.Clients.html#list_clients/0","title":"Boruta.Ecto.Admin.Clients.list_clients/0","type":"function"},{"doc":"Updates a client.Examplesiex&gt; update_client(client, %{field: new_value}) {:ok, %Client{}} iex&gt; update_client(client, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Clients.html#update_client/2","title":"Boruta.Ecto.Admin.Clients.update_client/2","type":"function"},{"doc":"Boruta.Ecto.Scope resource administration.","ref":"Boruta.Ecto.Admin.Scopes.html","title":"Boruta.Ecto.Admin.Scopes","type":"module"},{"doc":"Creates a scope.Examplesiex&gt; create_scope(%{field: value}) {:ok, %Scope{}} iex&gt; create_scope(%{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#create_scope/1","title":"Boruta.Ecto.Admin.Scopes.create_scope/1","type":"function"},{"doc":"Deletes a Scope.Examplesiex&gt; delete_scope(scope) {:ok, %Scope{}} iex&gt; delete_scope(scope) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#delete_scope/1","title":"Boruta.Ecto.Admin.Scopes.delete_scope/1","type":"function"},{"doc":"Gets a single scope.Raises Ecto.NoResultsError if the Scope does not exist.Examplesiex&gt; get_scope!(123) %Scope{} iex&gt; get_scope!(456) ** (Ecto.NoResultsError)","ref":"Boruta.Ecto.Admin.Scopes.html#get_scope!/1","title":"Boruta.Ecto.Admin.Scopes.get_scope!/1","type":"function"},{"doc":"","ref":"Boruta.Ecto.Admin.Scopes.html#get_scopes_by_ids/1","title":"Boruta.Ecto.Admin.Scopes.get_scopes_by_ids/1","type":"function"},{"doc":"Returns the list of scopes.Examplesiex&gt; list_scopes() [%Scope{}, ...]","ref":"Boruta.Ecto.Admin.Scopes.html#list_scopes/0","title":"Boruta.Ecto.Admin.Scopes.list_scopes/0","type":"function"},{"doc":"Updates a scope.Examplesiex&gt; update_scope(scope, %{field: new_value}) {:ok, %Scope{}} iex&gt; update_scope(scope, %{field: bad_value}) {:error, %Ecto.Changeset{}}","ref":"Boruta.Ecto.Admin.Scopes.html#update_scope/2","title":"Boruta.Ecto.Admin.Scopes.update_scope/2","type":"function"},{"doc":"Boruta.Ecto.Token resource administration.","ref":"Boruta.Ecto.Admin.Tokens.html","title":"Boruta.Ecto.Admin.Tokens","type":"module"},{"doc":"","ref":"Boruta.Ecto.Admin.Tokens.html#list_active_tokens/1","title":"Boruta.Ecto.Admin.Tokens.list_active_tokens/1","type":"function"},{"doc":"HTTP BasicAuth utilitiesProvide utilities to decode Basic authorization header as stated in RFC 7617 - The 'Basic' HTTP Authentication Scheme","ref":"Boruta.BasicAuth.html","title":"Boruta.BasicAuth","type":"module"},{"doc":"Decode given authorization header and returns an array containing username and password.Examplesiex&gt; Boruta.BasicAuth.decode(&quot;Basic dXNlcm5hbWU6cGFzc3dvcmQ=&quot;) {:ok, [&quot;username&quot;, &quot;password&quot;]} iex&gt; Boruta.BasicAuth.decode(&quot;bad_authorization_header&quot;) {:error, &quot;`bad_authorization_header` is not a valid Basic authorization header.&quot;}","ref":"Boruta.BasicAuth.html#decode/1","title":"Boruta.BasicAuth.decode/1","type":"function"},{"doc":"Behaviour to implement utilities to generate token value. This must be implemented in the module configured as token_generator set in config.exs","ref":"Boruta.Oauth.TokenGenerator.html","title":"Boruta.Oauth.TokenGenerator","type":"behaviour"},{"doc":"Generates a token value from token entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:generate/2","title":"Boruta.Oauth.TokenGenerator.generate/2","type":"callback"},{"doc":"Generates a secret from client entity.","ref":"Boruta.Oauth.TokenGenerator.html#c:secret/1","title":"Boruta.Oauth.TokenGenerator.secret/1","type":"callback"},{"doc":"Utility to validate the request according to the given parameters.","ref":"Boruta.Oauth.Validator.html","title":"Boruta.Oauth.Validator","type":"module"},{"doc":"Validates given OAuth parameters.Examplesiex&gt; validate(%{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }) {:ok, %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }} iex&gt; validate(%{}) {:error, &quot;Request is not a valid OAuth request. Need a grant_type or a response_type param.&quot;}","ref":"Boruta.Oauth.Validator.html#validate/2","title":"Boruta.Oauth.Validator.validate/2","type":"function"},{"doc":"Boruta OAuth errorsIntended to follow OAuth 2.0 errors. Additionnal errors are provided as purpose.","ref":"Boruta.Oauth.Error.html","title":"Boruta.Oauth.Error","type":"module"},{"doc":"Returns the URL to be redirected according to error format.","ref":"Boruta.Oauth.Error.html#redirect_to_url/1","title":"Boruta.Oauth.Error.redirect_to_url/1","type":"function"},{"doc":"Returns the OAuth error augmented with the format according to request type.","ref":"Boruta.Oauth.Error.html#with_format/2","title":"Boruta.Oauth.Error.with_format/2","type":"function"},{"doc":"","ref":"Boruta.Oauth.Error.html#t:t/0","title":"Boruta.Oauth.Error.t/0","type":"type"},{"doc":"Boruta OAuth/OpenID Connect provider coreBoruta is the core of an OAuth/OpenID Connect provider giving authorization business logic. A generator is provided to create phoenix controllers, views and templates to have a basic provider up and running.It is intended to follow RFCs:RFC 6749 - The OAuth 2.0 Authorization FrameworkRFC 7662 - OAuth 2.0 Token IntrospectionRFC 7009 - OAuth 2.0 Token RevocationRFC 7636 - Proof Key for Code Exchange by OAuth Public ClientsAnd specification from OpenID Connect:OpenID Connect core 1.0This package is meant to help to provide OAuth 2.0/OpenID Connect to your applications implementing part or all of authorization code, implicit, hybrid, client credentials, or resource owner password credentials grants. It also helps introspecting and revoking tokens.","ref":"readme.html","title":"Boruta OAuth/OpenID Connect provider core","type":"extras"},{"doc":"Documentation can be found here","ref":"readme.html#documentation","title":"Boruta OAuth/OpenID Connect provider core - Documentation","type":"extras"},{"doc":"A live example can be found here","ref":"readme.html#live-example","title":"Boruta OAuth/OpenID Connect provider core - Live example","type":"extras"},{"doc":"An example of integration can be found here","ref":"readme.html#integration-example","title":"Boruta OAuth/OpenID Connect provider core - Integration example","type":"extras"},{"doc":"Schemas migrationIf you plan to use Boruta builtin clients and tokens contexts, you'll need a migration for its Ecto schemas. This can be done by running:mix boruta.gen.migrationNote: You may need to run the task above in case of package upgrade to have up to date database schema.Implement ResourceOwners context (optional)In order to have user flows operational, You need to implement Boruta.Oauth.ResourceOwners behaviour.Here is an example implementation:defmodule MyApp.ResourceOwners do @behaviour Boruta.Oauth.ResourceOwners alias Boruta.Oauth.ResourceOwner alias MyApp.Accounts.User alias MyApp.Repo @impl Boruta.Oauth.ResourceOwners def get_by(username: username) do with %User{id: id, email: email} &lt;- Repo.get_by(User, email: username) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end def get_by(sub: sub) do with %User{id: id, email: email} = user &lt;- Repo.get_by(User, id: sub) do {:ok, %ResourceOwner{sub: id, username: email}} else _ -&gt; {:error, &quot;User not found.&quot;} end end @impl Boruta.Oauth.ResourceOwners def check_password(resource_owner, password) do user = Repo.get_by(User, id: resource_owner.sub) User.check_password(user, password) end @impl Boruta.Oauth.ResourceOwners def authorized_scopes(%ResourceOwner{}), do: [] endConfigurationBoruta provides several configuration options that you can customize in config.exs. Those have following default values:config :boruta, Boruta.Oauth, repo: MyApp.Repo, # mandatory cache_backend: Boruta.Cache, contexts: [ access_tokens: Boruta.Ecto.AccessTokens, clients: Boruta.Ecto.Clients, codes: Boruta.Ecto.Codes, resource_owners: MyApp.ResourceOwners, # mandatory for user flows scopes: Boruta.Ecto.Scopes ], max_ttl: [ authorization_code: 60, access_token: 60 * 60 * 24, id_token: 60 * 60 * 24, refresh_token: 60 * 60 * 24 * 30 ], token_generator: Boruta.TokenGenerator","ref":"readme.html#setup","title":"Boruta OAuth/OpenID Connect provider core - Setup","type":"extras"},{"doc":"This implementation follows an inverted hexagonal architecture, dependencies are inverted from Application layer.In order to expose endpoints of an OAuth/OpenID Connect server with Boruta, you need implement either the behaviour Boruta.Oauth.Application or the behaviours Boruta.Oauth.AuthorizeApplication, Boruta.Oauth.TokenApplication, Boruta.Oauth.IntrospectApplication and Boruta.Oauth.RevokeApplication to integrate these endpoints separatly. Those behaviours will help you creating callback functions which will be triggered by invoking token/2, authorize/2, introspect/2 and revoke/2 functions from Boruta.Oauth module.A generator is provided to create phoenix controllers, views and templates needed to implement a basic OAuth/OpenID Connect server.mix boruta.gen.controllersThis task will create needed files and give you a guide to finish your setup.","ref":"readme.html#integration","title":"Boruta OAuth/OpenID Connect provider core - Integration","type":"extras"},{"doc":"You can also create a client and test italias Boruta.Ecto alias Boruta.Oauth.Authorization alias Boruta.Oauth.{ClientCredentialsRequest, Token} # create a client {:ok, %Ecto.Client{id: client_id, secret: client_secret}} = Ecto.Admin.create_client(%{}) # obtain a token {:ok, %Token{value: value}} = Authorization.token(%ClientCredentialsRequest{client_id: client_id, client_secret: client_secret}) # check token {:ok, _token} = Authorization.AccessToken.authorize(value: value)","ref":"readme.html#straightforward-testing","title":"Boruta OAuth/OpenID Connect provider core - Straightforward testing","type":"extras"},{"doc":"Here are some code samples helping the integration:Notes about pkce","ref":"readme.html#guides","title":"Boruta OAuth/OpenID Connect provider core - Guides","type":"extras"},{"doc":"It is a work in progress, all feedbacks / feature requests / improvements are welcome","ref":"readme.html#feedback","title":"Boruta OAuth/OpenID Connect provider core - Feedback","type":"extras"},{"doc":"Notes for pkce extension","ref":"pkce.html","title":"Notes for pkce extension","type":"extras"},{"doc":"There are a few pre-requisites.Have a way to inject :current_user in the conn, otherwise implement it before continuing, also keep in mind that in most cases the :current_user is the same as the resource owner on OAuth.On our server, we need to create a client with pkce value as true.alias Boruta.Ecto.Admin.Clients {:ok, client} = %{authorization_code_ttl: 60, access_token_ttl: 60 * 60, pkce: true, name: &quot;My Awesome Client App&quot;, redirect_uris: [&quot;http://localhost:4000&quot;]} |&gt; Clients.create_client()We will get the client.id among others fields.","ref":"pkce.html#prerequisites","title":"Notes for pkce extension - Prerequisites","type":"extras"},{"doc":"From the client perspective, who is in charge of sending the code_challenge and code_challenge_method among other fields during the request of the code, there is a code_verifier variable which is a key concept to keep in mind because code_challenge depends on it and also depends on code_challenge_method, let's see an example.In our client, we must have an URL to request the /oauth/authorize endpoint to get the code. To build the URL we should follow a similar approach to the proposed.client_id = client.id code_verifier = &quot;a-strong-random-string&quot; state = &quot;a-random-verifiable-state-on-client&quot; # When the code challenge method is S256, we must follow the standard code_challenge = BASE64URL-ENCODE(SHA256(ASCII(code_verifier))) code_challenge_method = &quot;S256&quot; code_challenge = :crypto.hash(:sha256, code_verifier) |&gt; Base.url_encode64(padding: false) # Only if our client does not support sha256 crypto it goes through the plain method. Then code_challenge = code_verifier # # Keep in mind that it must be used only if your architecture does not support Sha256 crypto. otherwise use it. # # code_challenge_method = &quot;plain&quot; # code_challenge = code_verifier # Then we are ready to build your URL. url = &quot;http://localhost:4000/oauth/authorize?response_type=code&amp;client_id=\#{client_id}&amp;redirect_uri=http://localhost:4000&amp;state=\#{state}&amp;code_challenge=\#{code_challenge}&amp;code_challenge_method=\#{code_challenge_method}&quot; &quot;http://localhost:4000/oauth/authorize?response_type=code&amp;client_id=client-id&amp;redirect_uri=http://localhost:4000&amp;state=a-random-verifiable-state-on-client&amp;code_challenge=PdSbV6nNRlruDAqmULREHO_pLwfmNnNGA-HGIjmc6VA==&amp;code_challenge_method=S256&quot; You can paste the URL in your browser with a logged user and retrieve the code from the response URL.Having the code the next step is to retrieve a token, in this case, the client must call the oauth/token to get it.Based on the previous step, a request example could look like this.curl --location --request POST 'http://localhost:4000/oauth/token' \\ --header 'Content-Type: application/x-www-form-urlencoded' \\ --data-urlencode 'grant_type=authorization_code' \\ --data-urlencode 'client_id=c96951c5c-f7b5-4d03-ac09-657833d113df' \\ --data-urlencode 'code=4vlPc010GKutGlCYeT3VZFbyoVewmtNPOo0c5DXvt1iQ9pBd0BkeCutVwHWFNq8vzdTfIPppFGlhuYuOIWtvnU' \\ --data-urlencode 'code_verifier=a-strong-random-string' \\ --data-urlencode 'redirect_uri=http://localhost:4000' \\ --data-urlencode 'state=a-random-verifiable-state-on-client'It's important to notice that the code_verifier has the value previously generated and is not encrypted. This is because the server knows that you use encrypted method S256, and it implements the logic to handle it.And that is all. If your configuration is right, you will get a response like this.{&quot;access_token&quot;:&quot;BHYQabRwti673RVhoMnqXtrvgiEilawgaAj1KosrQV9pGQ4DBENXzhUHeSjZE4K02S8bNtlNL2gU9bzFhKMoQK&quot;,&quot;expires_in&quot;:3600,&quot;refresh_token&quot;:&quot;r90e4S9uaqH59xMO809Ws2uzWPtcaMlcF1J7fcaaSruE1AAc30WuykNAL73GGNECtmYezQSf2CzJGgQWPqdM5M&quot;,&quot;token_type&quot;:&quot;bearer&quot;}","ref":"pkce.html#flow-steps","title":"Notes for pkce extension - Flow steps","type":"extras"},{"doc":"Migration from 1.XVersion 2 of Boruta brings OpenID Connect, several changes were made in order to stick to the specification:","ref":"migration.html","title":"Migration from 1.X","type":"extras"},{"doc":"Boruta.Oauth.AuthorizeResponse and Boruta.Oauth.TokenResponse do not provide token value in value field but prefer giving value by token type code, access_token or id_token.%AuthorizeResponse{ type: &quot;code&quot;, value: value, expires_in: 60 }becomes%AuthorizeResponse{ type: :code, code: value, expires_in: 60 }","ref":"migration.html#oauth-response-structs-changes","title":"Migration from 1.X - OAuth response structs changes","type":"extras"},{"doc":"boruta.gen.migration task has been updated. Running the task will create required migrations to upgrade database schemas according to the updated Ecto.Schema modules.In order to have the schema up to date, you need to generate migrations and run themmix boruta.gen.migration mix ecto.migrate","ref":"migration.html#database-migrations","title":"Migration from 1.X - Database migrations","type":"extras"}]